from libc.stdint cimport uint32_t, uint16_t
from libc.stdlib cimport malloc, free
from libc.stdio cimport FILE, fopen, fwrite, fclose
cimport miniLZO

cdef lzo_compress(char *lzo_in, uint32_t len_in):
    cdef char *lzo_out = <char *>malloc(1 * 1024 * 1024)
    cdef void *workmem = malloc(1 * 1024 * 1024)
    cdef uint32_t len_out = 0
    cdef int result = 0
    cdef FILE *fp

    assert miniLZO.lzo_init() == 0, "LZO init failed."

    result = miniLZO.lzo1x_1_compress(lzo_in, len_in, lzo_out, &len_out, workmem)

    assert result == 0, "Compression failed."

    print("Compressed output length = {}".format(len_out))

    fp = fopen('lzo_out', 'wb')
    fwrite(lzo_out, len_out, 1, fp)
    fclose(fp)

    free(lzo_out)
    free(workmem)

    return result

def do_lzo_compress(lzo_in):
    encoded_input = lzo_in.encode('ascii')
    print("Input length = {}".format(len(encoded_input)))

    return lzo_compress(encoded_input, len(encoded_input))
